Find API keys with a query

  • POST also GET /_security/_query/api_key
Auth

Get a paginated list of API keys and their information. You can optionally filter the results with a query.

To use this API, you must have at least the manage_own_api_key or the read_security cluster privileges. If you have only the manage_own_api_key privilege, this API returns only the API keys that you own. If you have the read_security, manage_api_key, or greater privileges (including manage_security), this API returns all API keys regardless of ownership.

Required privileges

Cluster privileges manage_own_api_key read_security

Query parameters

with_limited_by boolean · default: false

Return the snapshot of the owner user's role descriptors associated with the API key. An API key's actual permission is the intersection of its assigned role descriptors and the owner user's role descriptors (effectively limited by it). An API key cannot retrieve any API key’s limited-by role descriptors (including itself) unless it has manage_api_key or higher privileges.

with_profile_uid boolean · default: false

Determines whether to also retrieve the profile UID for the API key owner principal. If it exists, the profile UID is returned under the profile_uid response field for each API key.

typed_keys boolean · default: false

Determines whether aggregation names are prefixed by their respective types in the response.

Request body

aggregations map string to object

Any aggregations to run over the corpus of returned API keys. Aggregations and queries work together. Aggregations are computed only on the API keys that match the query. This supports only a subset of aggregation types, namely: terms, range, date_range, missing, cardinality, value_count, composite, filter, and filters. Additionally, aggregations only run over the same subset of fields that query works with.

query object

A query to filter which API keys to return. If the query parameter is missing, it is equivalent to a match_all query. The query supports a subset of query types, including match_all, bool, term, terms, match, ids, prefix, wildcard, exists, range, and simple_query_string. You can query the following public information associated with an API key: id, type, name, creation, expiration, invalidated, invalidation, username, realm, and metadata.

Note

The queryable string values associated with API keys are internally mapped as keywords. Consequently, if no analyzer parameter is specified for a match query, then the provided match query string is interpreted as a single keyword value. Such a match query is hence equivalent to a term query.

Same fields as filter in aggregations
from number · default: 0

The starting document offset. It must not be negative. By default, you cannot page through more than 10,000 hits using the from and size parameters. To page through more hits, use the search_after parameter.

size number · default: 10

The number of hits to return. It must not be negative. The size parameter can be set to 0, in which case no API key matches are returned, only the aggregation results. By default, you cannot page through more than 10,000 hits using the from and size parameters. To page through more hits, use the search_after parameter.

search_after union[]

The search after definition.

Response

application/json
total number required

The total number of API keys found.

count number required

The number of API keys returned in the response.

api_keys object[] required

A list of API key information.

id string required

Id for the API key

name string required

Name of the API key.

type enum required

The type of the API key (e.g. rest or cross_cluster).

Values: rest cross_cluster
creation number required

Creation time for the API key in milliseconds.

expiration number

Expiration time for the API key in milliseconds.

invalidated boolean required

Invalidation status for the API key. If the key has been invalidated, it has a value of true. Otherwise, it is false.

invalidation number

If the key has been invalidated, invalidation time in milliseconds.

username string required

Principal for which this API key was created

realm string required

Realm name of the principal for which this API key was created.

realm_type string

Realm type of the principal for which this API key was created

metadata object required

Metadata of the API key

role_descriptors map string to object

The role descriptors assigned to this API key when it was created or last updated. An empty role descriptor means the API key inherits the owner user’s permissions.

limited_by string to object[]

The owner user’s permissions associated with the API key. It is a point-in-time snapshot captured at creation and subsequent updates. An API key’s effective permissions are an intersection of its assigned privileges and the owner user’s permissions.

profile_uid string

The profile uid for the API key owner principal, if requested and if it exists

_sort union[]

Sorting values when using the sort parameter with the security.query_api_keys API.

aggregations map string to oneOf

The aggregations result, if requested.